<template>
  <gw-input
    ref="input"
    v-currency="options"
    v-bind="attrs"
    v-on="inputListeners"></gw-input>
</template>

<script>
import { CurrencyDirective, setValue, parseCurrency } from 'vue-currency-input';
import GwInput from '../gw-input/GwInput.vue';

export default {
  name: 'GwCurrency',
  props: {
    currency: {
      type: [String, Object],
      default: 'BRL',
    },
    locale: {
      type: String,
      default: 'pt-BR',
    },
  },
  computed: {
    options() {
      return {
        ...this.$attrs,
        ...this.$props,
      };
    },
    attrs() {
      const {
        value,
        ...attrs
      } = this.$attrs || {};

      const {
        input,
      } = this.$refs || {};

      if (input && value) setValue(input.$refs.input, value);

      return attrs;
    },
    inputListeners() {
      const vm = this;
      return {
        ...this.$listeners,
        input: (value) => {
          vm.$emit('input', parseCurrency(value, this.options));
        },
      };
    },
  },
  directives: {
    currency: CurrencyDirective,
  },
  components: {
    GwInput,
  },
};
</script>
